Index: trunk/NEMOGCM/EXTERNAL/XMLIO_SERVER/src/IOSERVER/mod_event_server.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLIO_SERVER/src/IOSERVER/mod_event_server.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLIO_SERVER/src/IOSERVER/mod_event_server.f90	(revision 2767)
@@ -1,4 +1,4 @@
 MODULE mod_event_server
-  USE mod_pack, ONLY : unpack, unpack_field
+  USE mod_pack, ONLY : unpack_data, unpack_field
   USE mod_event_parameters
   USE iomanager
@@ -16,5 +16,5 @@
     is_terminated=.FALSE.
     
-    CALL unpack(event_id)
+    CALL unpack_data(event_id)
     
     SELECT CASE (event_id)
@@ -87,5 +87,5 @@
     INTEGER :: id_size
    
-    CALL unpack(id_size)
+    CALL unpack_data(id_size)
     CALL sub_internal(id_size)
      
@@ -96,5 +96,5 @@
       CHARACTER(LEN=id_size) :: id     
      
-       CALL unpack(id)
+       CALL unpack_data(id)
      
        CALL iom__swap_context(id)
@@ -109,5 +109,5 @@
     INTEGER :: name_size
    
-    CALL unpack(name_size)
+    CALL unpack_data(name_size)
     CALL sub_internal(name_size)
      
@@ -118,5 +118,5 @@
       CHARACTER(LEN=name_size) :: filename     
      
-       CALL unpack(filename)
+       CALL unpack_data(filename)
      
        CALL iom__parse_xml_file(filename)
@@ -132,5 +132,5 @@
     INTEGER :: nj_glo
    
-    CALL unpack(name_size)
+    CALL unpack_data(name_size)
     CALL sub_internal(name_size)
      
@@ -141,7 +141,7 @@
       CHARACTER(LEN=name_size) :: name     
      
-       CALL unpack(name)
-       CALL unpack(ni_glo)
-       CALL unpack(nj_glo)
+       CALL unpack_data(name)
+       CALL unpack_data(ni_glo)
+       CALL unpack_data(nj_glo)
      
        CALL iom__set_grid_dimension(name,ni_glo,nj_glo)
@@ -161,5 +161,5 @@
     REAL,ALLOCATABLE :: lat(:,:)
 
-    CALL unpack(name_size)
+    CALL unpack_data(name_size)
     CALL sub_internal(name_size)
      
@@ -170,15 +170,15 @@
       CHARACTER(LEN=name_size) :: name     
      
-       CALL unpack(name)
-    
-       CALL unpack(ni)
-       CALL unpack(nj)
-       CALL unpack(ibegin)
-       CALL unpack(jbegin)
+       CALL unpack_data(name)
+    
+       CALL unpack_data(ni)
+       CALL unpack_data(nj)
+       CALL unpack_data(ibegin)
+       CALL unpack_data(jbegin)
     
        ALLOCATE(lon(ni,nj))
        ALLOCATE(lat(ni,nj))
-       CALL unpack(lon)
-       CALL unpack(lat)
+       CALL unpack_data(lon)
+       CALL unpack_data(lat)
     
        CALL iom__set_grid_domain(name,ni,nj,ibegin,jbegin,lon,lat)
@@ -193,5 +193,5 @@
     INTEGER :: name_size
 
-    CALL unpack(name_size)
+    CALL unpack_data(name_size)
     CALL sub_internal(name_size)
      
@@ -202,5 +202,5 @@
       CHARACTER(LEN=name_size) :: name     
      
-       CALL unpack(name)
+       CALL unpack_data(name)
        CALL iom__set_grid_type_nemo(name)
 
@@ -213,5 +213,5 @@
     INTEGER :: name_size
 
-    CALL unpack(name_size)
+    CALL unpack_data(name_size)
     CALL sub_internal(name_size)
      
@@ -224,7 +224,7 @@
       INTEGER                  :: offset
       
-       CALL unpack(name)
-       CALL unpack(nbp)
-       CALL unpack(offset)
+       CALL unpack_data(name)
+       CALL unpack_data(nbp)
+       CALL unpack_data(offset)
        CALL iom__set_grid_type_lmdz(name,nbp,offset)
 
@@ -239,5 +239,5 @@
     REAL,ALLOCATABLE :: vert_value(:)
     
-    CALL unpack(name_size)
+    CALL unpack_data(name_size)
     CALL sub_internal(name_size)
 
@@ -248,8 +248,8 @@
       CHARACTER(LEN=name_size) :: name
     
-      CALL unpack(name)
-      CALL unpack(vert_size)
+      CALL unpack_data(name)
+      CALL unpack_data(vert_size)
       ALLOCATE(vert_value(vert_size))
-      CALL unpack(vert_value) 
+      CALL unpack_data(vert_value) 
       
       CALL iom__set_vert_axis(name,vert_value)
@@ -264,7 +264,7 @@
     REAL      :: zdt
       
-    CALL unpack(itau0)
-    CALL unpack(zjulian)
-    CALL unpack(zdt)
+    CALL unpack_data(itau0)
+    CALL unpack_data(zjulian)
+    CALL unpack_data(zdt)
     
     CALL iom__set_time_parameters(itau0,zjulian,zdt)
@@ -277,5 +277,5 @@
     INTEGER :: lenc
       
-    CALL unpack(lenc)
+    CALL unpack_data(lenc)
     CALL sub_internal(lenc)
   
@@ -286,5 +286,5 @@
       CHARACTER(len=lenc) :: varname
       
-      CALL unpack(varname)
+      CALL unpack_data(varname)
       
       CALL iom__enable_field(varname)
@@ -298,5 +298,5 @@
     INTEGER :: lenc
       
-    CALL unpack(lenc)
+    CALL unpack_data(lenc)
     CALL sub_internal(lenc)
   
@@ -307,5 +307,5 @@
       CHARACTER(len=lenc) :: varname
       
-      CALL unpack(varname)
+      CALL unpack_data(varname)
       
       CALL iom__disable_field(varname)
@@ -321,6 +321,6 @@
     INTEGER :: dim1
       
-    CALL unpack(lenc)
-    CALL unpack(dim1)
+    CALL unpack_data(lenc)
+    CALL unpack_data(dim1)
     CALL sub_internal(lenc,dim1)
   
@@ -333,5 +333,5 @@
       REAL                :: var(dim1)
       
-      CALL unpack(varname)
+      CALL unpack_data(varname)
       CALL unpack_field(var)
       
@@ -347,7 +347,7 @@
     INTEGER :: dim2
       
-    CALL unpack(lenc)
-    CALL unpack(dim1)
-    CALL unpack(dim2)
+    CALL unpack_data(lenc)
+    CALL unpack_data(dim1)
+    CALL unpack_data(dim2)
     CALL sub_internal(lenc,dim1,dim2)
   
@@ -361,5 +361,5 @@
       REAL                :: var(dim1,dim2)
       
-      CALL unpack(varname)
+      CALL unpack_data(varname)
       CALL unpack_field(var)
       
@@ -377,8 +377,8 @@
     INTEGER :: dim3
     
-    CALL unpack(lenc)
-    CALL unpack(dim1)
-    CALL unpack(dim2)
-    CALL unpack(dim3)
+    CALL unpack_data(lenc)
+    CALL unpack_data(dim1)
+    CALL unpack_data(dim2)
+    CALL unpack_data(dim3)
     CALL sub_internal(lenc,dim1,dim2,dim3)
  
@@ -395,5 +395,5 @@
       REAL                :: var(dim1,dim2,dim3)
         
-      CALL unpack(varname)
+      CALL unpack_data(varname)
       CALL unpack_field(var)
        
@@ -409,5 +409,5 @@
     INTEGER :: timestep
      
-    CALL unpack(timestep)
+    CALL unpack_data(timestep)
     CALL iom__set_timestep(timestep)
     
@@ -419,5 +419,5 @@
     INTEGER :: lenc
       
-    CALL unpack(lenc)
+    CALL unpack_data(lenc)
     CALL sub_internal(lenc)
   
@@ -428,5 +428,5 @@
       CHARACTER(len=lenc) :: str_calendar
       
-      CALL unpack(str_calendar)
+      CALL unpack_data(str_calendar)
       
       CALL iom__set_calendar(str_calendar)
@@ -449,5 +449,5 @@
      INTEGER        :: len_id
      
-     CALL unpack(len_id)
+     CALL unpack_data(len_id)
      CALL sub_internal
    CONTAINS
@@ -456,6 +456,6 @@
        CHARACTER(LEN=len_id) :: id
        
-       CALL unpack(id)
-       CALL unpack(attrib)
+       CALL unpack_data(id)
+       CALL unpack_data(attrib)
        CALL iom__set_attribut(id,attrib)
        CALL attr_deallocate(attrib)