Index: branches/2011/dev_r2787_NOCS_NEPTUNE/NEMOGCM/NEMO/OPA_SRC/DYN/dynnept.F90
===================================================================
--- branches/2011/dev_r2787_NOCS_NEPTUNE/NEMOGCM/NEMO/OPA_SRC/DYN/dynnept.F90	(revision 2795)
+++ branches/2011/dev_r2787_NOCS_NEPTUNE/NEMOGCM/NEMO/OPA_SRC/DYN/dynnept.F90	(revision 2808)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                       ***  MODULE  dynnept  ***
-   !! Ocean dynamics: topostress as proposed by Greg Holloway,
+   !! Ocean dynamics: Neptune effect as proposed by Greg Holloway,
    !!                 recoded version of simplest case (u*, v* only)
    !!======================================================================
@@ -19,5 +19,4 @@
    !! smooth_topo2         :
    !!----------------------------------------------------------------------
-#if  defined key_dynnept  ||  defined key_esopa
    USE oce              ! ocean dynamics and tracers
    USE dom_oce          ! ocean space and time domain
@@ -33,6 +32,6 @@
 
    !! * Routine accessibility
-   PUBLIC dyn_nept_init       ! routine called by nemogcm.F90
-   PUBLIC dyn_cor_topo        ! routine called by step.F90
+   PUBLIC dyn_nept_init      ! routine called by nemogcm.F90
+   PUBLIC dyn_cor_topo       ! routine called by step.F90
    !! dynnept_alloc()     is called only by dyn_nept_init, within this module
    !! div_cur_nept_init   is called only by dyn_nept_init, within this module
@@ -40,15 +39,15 @@
 
    !! * Shared module variables
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)    :: zunep, zvnep  ! topostress u and v
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  :: zhdivnep      ! hor. div for Neptune vel.
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  :: zmrotnep      ! curl for Neptune vel.
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)    :: zunep, zvnep  ! Neptune u and v
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  :: zhdivnep      ! hor. div for Neptune vel.
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  :: zmrotnep      ! curl for Neptune vel.
 
 
    !! * Namelist nam_dynnept variables
-   LOGICAL    ::  ln_neptsimp    = .FALSE.  ! yes/no use cortopo
-
-   LOGICAL    ::  ln_smoothtopo  = .FALSE.  ! yes/no smooth zunep, zvnep
-   REAL(wp)   ::  rn_tslse       =  1.2e4   ! value of L at the equator
-   REAL(wp)   ::  rn_tslsp       =  3.0e3   ! value of L at the pole
+   LOGICAL, PUBLIC  ::  ln_neptsimp    = .FALSE.  ! yes/no simplified neptune
+
+   LOGICAL          ::  ln_smoothtopo  = .FALSE.  ! yes/no smooth zunep, zvnep
+   REAL(wp)         ::  rn_tslse       =  1.2e4   ! value of L at the equator
+   REAL(wp)         ::  rn_tslsp       =  3.0e3   ! value of L at the pole
 
    !! * Module variables
@@ -87,5 +86,5 @@
       !! ** History :  1.0  !   07-05  (Zeliang Wang)   Original code for zunep, zvnep
       !!               1.1  !   07-06  (Michael Dunphy) namelist and  initialisation
-      !!               2.0  ! 2011-06  (Jeff Blundell, NOCS)
+      !!               2.0  ! 2011-07  (Jeff Blundell, NOCS)
       !!                    ! Simplified form for temporally invariant u*, v*
       !!                    ! Horizontal and vertical diffusivity formulations removed
@@ -112,10 +111,10 @@
       !!----------------------------------------------------------------------
 
-      ! Define the topostress parameters
-      ! ================================
+      ! Define the (simplified) Neptune parameters
+      ! ==========================================
 
 !!    WRITE(numout,*) ' start dynnept namelist'
 !!    CALL FLUSH(numout)
-      REWIND( numnam )                  ! Read Namelist nam_dynnept:  Topostress
+      REWIND( numnam )                  ! Read Namelist nam_dynnept:  Simplified Neptune
       READ  ( numnam, nam_dynnept )
 !!    WRITE(numout,*) ' dynnept namelist done'
@@ -124,5 +123,5 @@
       IF(lwp) THEN                      ! Control print
          WRITE(numout,*)
-         WRITE(numout,*) 'dyn_nept_init : Topostress module enabled'
+         WRITE(numout,*) 'dyn_nept_init : Simplified Neptune module enabled'
          WRITE(numout,*) '~~~~~~~~~~~~~'
          WRITE(numout,*) ' -->   Reading namelist nam_dynnept parameters:'
@@ -190,5 +189,5 @@
       IF( ln_smoothtopo ) THEN
          CALL smooth_topo2( htn, ht, .TRUE. )
-      !! overwrites ht with a smoothed verion of htn
+      !! overwrites ht with a smoothed version of htn
       ELSE
          ht(:,:) = htn(:,:)
@@ -212,5 +211,5 @@
       IF( ln_smoothtopo ) THEN
          CALL smooth_topo2( hu, hu_n, .TRUE. )
-      !! overwrites hu_n with a smoothed verion of hu
+      !! overwrites hu_n with a smoothed version of hu
       ELSE
          hu_n(:,:) = hu(:,:)
@@ -229,5 +228,5 @@
       IF( ln_smoothtopo ) THEN
          CALL smooth_topo2( hv, hv_n, .TRUE. )
-      !! overwrites hv_n with a smoothed verion of hv
+      !! overwrites hv_n with a smoothed version of hv
       ELSE
          hv_n(:,:) = hv(:,:)
@@ -548,22 +547,3 @@
    END SUBROUTINE smooth_topo2
 
-#else
-   !!------------------------------------------------------------------------
-   !!   Dummy module :                 No Topostress
-   !!------------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE dyn_nept_init              ! Dummy routine
-      WRITE(*,*) 'dyn_nept_init: You should not have seen this print! error?'
-   END SUBROUTINE dyn_nept_init
-
-   SUBROUTINE dyn_cor_topo( kt )        ! Dummy routine
-      INTEGER, INTENT(in) :: kt
-      WRITE(*,*) 'dyn_cor_topo: You should not have seen this print! error?', kt
-   END SUBROUTINE dyn_cor_topo
-
-   SUBROUTINE div_cur_nept_init         ! Dummy routine
-      WRITE(*,*) 'div_cur_nept_init: You should not have seen this print! error?'
-   END SUBROUTINE div_cur_nept_init
-#endif
-   !!======================================================================
 END MODULE dynnept