Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/CONFIG/makenemo
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/CONFIG/makenemo	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/CONFIG/makenemo	(revision 2815)
@@ -90,5 +90,5 @@
 export COMPIL_DIR=${MAIN_DIR}/TOOLS/COMPILE
 export NEMO_DIR=${MAIN_DIR}/NEMO
-export AGRIFUSE=10
+export AGRIFUSE=""
 
 declare -a TAB
@@ -269,5 +269,5 @@
 
 #- We look after agrif
-grep key_agrif ${COMPIL_DIR}/cpp.fcm && export AGRIFUSE=1 && export USEBLD=${USEBLD/xag/}
+grep key_agrif ${COMPIL_DIR}/cpp.fcm && export AGRIFUSE="WITH_AGRIF" && export USEBLD=${USEBLD/xag/}
 . ${COMPIL_DIR}/Fprep_agrif.sh ${NEW_CONF} ${NEMO_TDIR} || exit
 
@@ -284,10 +284,4 @@
 if [ "${NBR_PRC}" -gt 0 ]; then
     cd ${NEMO_TDIR}/${NEW_CONF} || cd -
-
-#if AGRIF we do a first preprocessing
-    if [ ${#x_c} -eq 0 ]; then
-        [ "$AGRIFUSE" == 1 ] && fcm build --ignore-lock -s 2 ${COMPIL_DIR}/$USEBLD
-        [ "$AGRIFUSE" == 1 ] && rm -rf  ${NEMO_TDIR}/${NEW_CONF}/BLD/*
-    fi
     fcm build ${x_c} --ignore-lock -v 1 -j ${NBR_PRC} ${COMPIL_DIR}/$USEBLD || cd -
     [ -f ${NEMO_TDIR}/${NEW_CONF}/BLD/bin/nemo.exe ] && ln -sf ${NEMO_TDIR}/${NEW_CONF}/BLD/bin/nemo.exe  ${CONFIG_DIR}/${NEW_CONF}/EXP00/opa
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/NST_SRC/agrif2model.F90
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/NST_SRC/agrif2model.F90	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/NST_SRC/agrif2model.F90	(revision 2815)
@@ -1,3 +1,4 @@
 #if defined key_agrif
+
    !!----------------------------------------------------------------------
    !! NEMO/NST 3.3 , NEMO Consortium (2010)
@@ -5,5 +6,5 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
+!$AGRIF_DO_NOT_TREAT
    SUBROUTINE Agrif_Set_numberofcells(Agrif_Gr)
       !!---------------------------------------------
@@ -11,4 +12,5 @@
       !!--------------------------------------------- 
       USE Agrif_Types
+      USE nemogcm
       IMPLICIT NONE
 
@@ -92,4 +94,5 @@
 
    END SUBROUTINE Agrif_comm_def
+!$AGRIF_END_DO_NOT_TREAT
 #else
    SUBROUTINE Agrif2Model
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 2815)
@@ -8,11 +8,11 @@
    !!            3.3  !  2010-09  (D. Storkey) add ice boundary conditions
    !!----------------------------------------------------------------------
+   USE par_oce         ! ocean parameters
+   USE lib_mpp         ! distributed memory computing
 #if defined key_bdy 
    !!----------------------------------------------------------------------
    !!   'key_bdy'                      Unstructured Open Boundary Condition
    !!----------------------------------------------------------------------
-   USE par_oce         ! ocean parameters
    USE bdy_par         ! Unstructured boundary parameters
-   USE lib_mpp         ! distributed memory computing
 
    IMPLICIT NONE
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 2815)
@@ -9,4 +9,13 @@
    !!            3.3  !  2010-09  (D.Storkey and E.O'Dea)  bug fixes
    !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers 
+   USE dom_oce         ! ocean space and time domain
+   USE iom
+   USE in_out_manager  ! I/O units
+   USE phycst          ! physical constants
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE bdy_par         ! Unstructured boundary parameters
+   USE bdy_oce         ! ocean open boundary conditions
+   USE daymod          ! calendar
 #if defined key_bdy
    !!----------------------------------------------------------------------
@@ -24,13 +33,4 @@
    !!      vset          :/
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers 
-   USE dom_oce         ! ocean space and time domain
-   USE iom
-   USE in_out_manager  ! I/O units
-   USE phycst          ! physical constants
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE bdy_par         ! Unstructured boundary parameters
-   USE bdy_oce         ! ocean open boundary conditions
-   USE daymod          ! calendar
 
    IMPLICIT NONE
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/OBS/obs_sla_types.F90
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/OBS/obs_sla_types.F90	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/OBS/obs_sla_types.F90	(revision 2815)
@@ -12,4 +12,5 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
+   USE par_oce
 
    IMPLICIT NONE
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/OBS/obs_types.F90
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/OBS/obs_types.F90	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/OBS/obs_types.F90	(revision 2815)
@@ -27,4 +27,6 @@
    !!        !  06-10  (A. Weaver) Cleanup
    !!---------------------------------------------------------------------
+
+   USE par_oce 
 
    IMPLICIT NONE
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/par_oce.F90
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/par_oce.F90	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/NEMO/OPA_SRC/par_oce.F90	(revision 2815)
@@ -9,4 +9,8 @@
    !!----------------------------------------------------------------------
    USE par_kind          ! kind parameters
+#if defined key_agrif
+   USE agrif_util
+   USE agrif_types
+#endif 
 
    IMPLICIT NONE
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/Fprep_agrif.sh
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/Fprep_agrif.sh	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/Fprep_agrif.sh	(revision 2815)
@@ -56,5 +56,5 @@
 
 #- AGRIF conv
-if [ "$AGRIFUSE" == 1 ]; then
+if [ "$AGRIFUSE" == "WITH_AGRIF" ]; then
 
 #- CONV
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/agriffc.sh
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/agriffc.sh	(revision 2815)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/agriffc.sh	(revision 2815)
@@ -0,0 +1,83 @@
+#!/bin/bash
+#set -x
+set -o posix
+#set -u
+#set -e
+#+
+#
+# ==========
+# agriffc.sh
+# ==========
+#
+# ----------------------------
+# Preform Agrif pre-processing
+# ----------------------------
+#
+# SYNOPSIS
+# ========
+#
+# ::
+#
+#  $ agrifpp.sh
+#
+#
+# DESCRIPTION
+# ===========
+#
+#
+# Look after key agrif, if yes the conv is used first , then compilation is performed.
+# Without key_agrif, compilation is performed
+#
+# EXAMPLES
+# ========
+#
+# ::
+#
+#  $ ./agriffc.sh WITH_AGRIF COMPILER LINETO COMPILE
+# 
+#  or
+#
+#  $ ./agriffc.sh COMPILER LINETOCOMPILE
+#
+# TODO
+# ====
+#
+# option debug
+#
+#
+# EVOLUTIONS
+# ==========
+#
+# $Id$
+#
+#
+#
+#   * creation
+#
+#-
+
+#- compiler
+COMP=$1
+shift
+WITH_AGRIF=$( echo  "$@" | grep WITH_AGRIF )
+#- line to compile
+TOCOMP=${@/WITH_AGRIF/}
+#- file to compile
+MYFILE=`echo $TOCOMP |awk -F" " '{print $NF}' `  
+MYFILE2=$(basename $MYFILE)
+MYDIR=$(dirname $MYFILE)
+#- cpp keys
+KEYS=${FPPKEYS//key/-Dkey}
+#- compilation options
+OPTS=${TOCOMP/$KEYS/}
+OPTS=${OPTS%$MYFILE} 
+
+if [ "${#WITH_AGRIF}" -gt 0 ]; then
+   \cp $MYFILE ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/.
+   ( cd ${NEMO_TDIR}/${NEW_CONF}/OPAFILES ; ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/conv agrif_opa.in -rm -comdirin ./  -comdirout AGRIF_MODELFILES/ -convfile ${MYFILE2} > /dev/null )
+   cpp  $KEYS -P -traditional -I ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/AGRIF_INC ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/AGRIF_MODELFILES/$MYFILE2 > ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/$MYFILE2
+#   sed 's/[ 	]*$//' OPAFILES/AGRIF_MODELFILES/${MYFILE}> OPAFILES/${MYFILE}
+   $COMP $OPTS ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/${MYFILE2} 
+else
+   $COMP $TOCOMP
+fi
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/agrifpp.sh
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/agrifpp.sh	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/agrifpp.sh	(revision 2815)
@@ -10,7 +10,7 @@
 # ==========
 #
-# ----------------------------
-# Preform AGrif pre-processing
-# ----------------------------
+# ---------------------------
+# Preform  CPP pre-processing
+# ---------------------------
 #
 # SYNOPSIS
@@ -26,5 +26,6 @@
 #
 #
-# Look after key agrif, if yes the conv is used, otherwise standard pre-processing is performed.
+# Look after key agrif, if yes agrif2model is not yet pre-pocessed, otehrwise we use
+# standard cpp.
 #
 # EXAMPLES
@@ -33,9 +34,6 @@
 # ::
 #
-#  $ ./agrifpp.sh 1 -Dkey
+#  $ ./agrifpp.sh -Dkey   
 # 
-#  or
-#
-#  $ ./agrifpp.sh -Dkey
 #
 # TODO
@@ -56,33 +54,11 @@
 #-
 
-if [ "$1" == "1" ]; then
-   shift
-   MYFILE=`echo $* |awk -F" " '{print $NF}' `  
-   FPP_OPT=` echo $* |awk '{  for (i=1 ; i<NF ; i++ )  { printf " %s",  $i } }'`
+MYFILE=`echo $* |awk -F" " '{print $NF}' `  
+FPP_OPT=` echo $* |awk '{  for (i=1 ; i<NF ; i++ )  { printf " %s",  $i } }'`
+AGRIF_ACTIVATED=$( echo  $FPP_OPT | grep key_agrif )
 
-
-   if [ "${MYFILE}" != "par_oce.F90" -a  ! -f ${NEMO_TDIR}/${NEW_CONF}}/OPAFILES/param_done ]; then
-      cpp ${FPP_OPT} ${CONFIG_DIR}/${NEW_CONF}/WORK/par_oce.F90 > ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/par_oce.F90
-      (cd ${NEMO_TDIR}/${NEW_CONF}/OPAFILES ; ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/conv agrif_opa.in -rm -comdirin ./ -comdirout AGRIF_MODELFILES/ -convfile par_oce.F90 > /dev/null )
-      cpp ${FPP_OPT}  -I${NEMO_TDIR}/${NEW_CONF}/OPAFILES/AGRIF_INC  ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/AGRIF_MODELFILES/par_oce.F90 > ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/par_oce.F90
-      touch ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/param_done
-   elif  [ "${MYFILE}" == "par_oce.F90" -a -f ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/param_done ] ; then
-      cd  ${NEMO_TDIR}/${NEW_CONF}/OPAFILES
-      cpp ${FPP_OPT} -I${NEMO_TDIR}/${NEW_CONF}/OPAFILES/AGRIF_INC ${MYFILE}
-      exit
-   fi
-
-   if [ "${MYFILE}" == agrif2model.F90 ]; then
-      cpp  -I${NEMO_TDIR}/${NEW_CONF}/OPAFILES/AGRIF_INC $@
-      exit
-   fi 
-
-   cpp  -I${NEMO_TDIR}/${NEW_CONF}/OPAFILES/AGRIF_INC $@ > ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/${MYFILE}
-   ( cd ${NEMO_TDIR}/${NEW_CONF}/OPAFILES ; ${NEMO_TDIR}/${NEW_CONF}/OPAFILES/conv agrif_opa.in -rm -comdirin ./ -comdirout AGRIF_MODELFILES/ -convfile ${MYFILE} > /dev/null )
-   cd  ${NEMO_TDIR}/${NEW_CONF}
-   sed 's/[ 	]*$//' OPAFILES/AGRIF_MODELFILES/${MYFILE}> OPAFILES/${MYFILE}
-   cpp ${FPP_OPT} -IOPAFILES/AGRIF_INC OPAFILES/${MYFILE} 
+if [ "$MYFILE" == "agrif2model.F90" -a "${#AGRIF_ACTIVATED}" -gt 0 ]; then
+   cat  $MYFILE
 else
-   shift
    cpp $@
 fi
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bld.cfg
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bld.cfg	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bld.cfg	(revision 2815)
@@ -25,11 +25,4 @@
 src::nemo                 $CONFIG_DIR/$NEW_CONF/WORK
 
-#bld::lib::xmlf90           xmlf90
-#bld::lib::xmlio            xmlio
-#bld::lib::ioserver         ioserver
-#bld::lib::ioipsl           ioipsl
-#bld::lib::agrif            agrif
-#bld::lib::nemo             nemo
-#bld::target libxmlf90.a libioserver.a libxmlio.a libioipsl.a libagrif.a libnemo.a server.exe nemo.exe
 bld::target  server.exe nemo.exe
 bld::exe_dep
@@ -39,7 +32,8 @@
 
 
-bld::tool::fc        %FC 
+bld::tool::fc        $TOOLS_DIR/COMPILE/agriffc.sh %FC 
 bld::tool::fflags    %FCFLAGS %USER_INC
-bld::tool::fflags::agrif   %FFLAGS %USER_INC
+bld::tool::fflags::nemo     $AGRIFUSE %FCFLAGS %USER_INC 
+bld::tool::fflags::agrif    %FFLAGS %USER_INC
 bld::tool::ld        %LD
 bld::tool::ldflags   %LDFLAGS %USER_LIB
@@ -55,9 +49,9 @@
 bld::pp::agrif    1
 bld::tool::fpp       $COMPIL_DIR/agrifpp.sh
-bld::tool::fppflags::nemo ${AGRIFUSE} %FPPFLAGS
-bld::tool::fppflags::xmlio    0 %FPPFLAGS
-bld::tool::fppflags::ioserver 0 %FPPFLAGS
-bld::tool::fppflags::ioipsl   0 %FPPFLAGS
-bld::tool::fppflags::agrif    0 %FPPFLAGS
+bld::tool::fppflags::nemo      %FPPFLAGS
+bld::tool::fppflags::xmlio     %FPPFLAGS
+bld::tool::fppflags::ioserver  %FPPFLAGS
+bld::tool::fppflags::ioipsl    %FPPFLAGS
+bld::tool::fppflags::agrif     %FPPFLAGS
 
 # Ignore the following dependencies
@@ -77,4 +71,12 @@
 bld::excl_dep        use::mod_comprism_proto
 bld::excl_dep        use::mkl_dfti
+bld::excl_dep        h::setnumberofcells.h
+bld::excl_dep        h::getnumberofcells.h
+bld::excl_dep        h::include_use_alloc_agrif.h
+bld::excl_dep        h::allocations_calls_agrif.h
+bld::excl_dep        h::modtype_agrif.h
+bld::excl_dep        h::probdim_agrif.h
+bld::excl_dep        h::keys_agrif.h
+
 # Don't generate interface files
 bld::tool::geninterface none
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bldxag.cfg
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bldxag.cfg	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bldxag.cfg	(revision 2815)
@@ -31,5 +31,6 @@
 
 
-bld::tool::fc        %FC 
+bld::tool::fc        $TOOLS_DIR/COMPILE/agriffc.sh %FC 
+bld::tool::fflags::nemo     $AGRIFUSE %FCFLAGS %USER_INC 
 bld::tool::fflags    %FCFLAGS %USER_INC
 bld::tool::ld        %LD
@@ -45,8 +46,8 @@
 bld::pp::nemo     1
 bld::tool::fpp       $COMPIL_DIR/agrifpp.sh
-bld::tool::fppflags::nemo ${AGRIFUSE} %FPPFLAGS
-bld::tool::fppflags::xmlio    0 %FPPFLAGS
-bld::tool::fppflags::ioserver 0 %FPPFLAGS
-bld::tool::fppflags::ioipsl   0 %FPPFLAGS
+bld::tool::fppflags::nemo      %FPPFLAGS
+bld::tool::fppflags::xmlio     %FPPFLAGS
+bld::tool::fppflags::ioserver  %FPPFLAGS
+bld::tool::fppflags::ioipsl    %FPPFLAGS
 
 # Ignore the following dependencies
@@ -66,4 +67,12 @@
 bld::excl_dep        use::mod_comprism_proto
 bld::excl_dep        use::mkl_dfti
+bld::excl_dep        h::setnumberofcells.h
+bld::excl_dep        h::getnumberofcells.h
+bld::excl_dep        h::include_use_alloc_agrif.h
+bld::excl_dep        h::allocations_calls_agrif.h
+bld::excl_dep        h::modtype_agrif.h
+bld::excl_dep        h::probdim_agrif.h
+bld::excl_dep        h::keys_agrif.h
+
 # Don't generate interface files
 bld::tool::geninterface none
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bldxio.cfg
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bldxio.cfg	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bldxio.cfg	(revision 2815)
@@ -11,5 +11,5 @@
 inc $COMPIL_DIR/cpp.fcm
 
-search_src           1
+#search_src           1
 
 src::ioipsl               $MAIN_DIR/EXTERNAL/IOIPSL/src
@@ -24,7 +24,8 @@
 
 
-bld::tool::fc        %FC 
-bld::tool::fflags    %FCFLAGS %USER_INC
-bld::tool::fflags::agrif   %FFLAGS %USER_INC
+bld::tool::fc    $TOOLS_DIR/COMPILE/agriffc.sh %FC    
+bld::tool::fflags      %FCFLAGS %USER_INC
+bld::tool::fflags::nemo     $AGRIFUSE %FCFLAGS %USER_INC 
+bld::tool::fflags::agrif    %FFLAGS %USER_INC
 bld::tool::ld        %LD
 bld::tool::ldflags   %LDFLAGS %USER_LIB
@@ -37,8 +38,9 @@
 bld::pp::nemo     1
 bld::pp::agrif    1
-bld::tool::fpp       $COMPIL_DIR/agrifpp.sh
-bld::tool::fppflags::nemo ${AGRIFUSE} %FPPFLAGS
-bld::tool::fppflags::ioipsl   0 %FPPFLAGS
-bld::tool::fppflags::agrif    0 %FPPFLAGS
+bld::tool::fpp       $TOOLS_DIR/COMPILE/agrifpp.sh
+bld::tool::fppflags::nemo  %FPPFLAGS
+bld::tool::fppflags::ioipsl    %FPPFLAGS
+bld::tool::fppflags::agrif     %FPPFLAGS
+
 
 # Ignore the following dependencies
@@ -58,4 +60,13 @@
 bld::excl_dep        use::mod_comprism_proto
 bld::excl_dep        use::mkl_dfti
+bld::excl_dep        h::setnumberofcells.h
+bld::excl_dep        h::getnumberofcells.h
+bld::excl_dep        h::include_use_alloc_agrif.h
+bld::excl_dep        h::allocations_calls_agrif.h
+bld::excl_dep        h::modtype_agrif.h
+bld::excl_dep        h::probdim_agrif.h
+bld::excl_dep        h::keys_agrif.h
+
+
 # Don't generate interface files
 bld::tool::geninterface none
Index: /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bldxioxag.cfg
===================================================================
--- /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bldxioxag.cfg	(revision 2814)
+++ /branches/2011/dev_r2802_LOCEAN10_agrif_lim/NEMOGCM/TOOLS/COMPILE/bldxioxag.cfg	(revision 2815)
@@ -23,6 +23,7 @@
 
 
-bld::tool::fc        %FC 
-bld::tool::fflags    %FCFLAGS %USER_INC
+bld::tool::fc               $TOOLS_DIR/COMPILE/agriffc.sh %FC    
+bld::tool::fflags           %FCFLAGS %USER_INC
+bld::tool::fflags::nemo     $AGRIFUSE %FCFLAGS %USER_INC 
 bld::tool::ld        %LD
 bld::tool::ldflags   %LDFLAGS %USER_LIB
@@ -35,6 +36,6 @@
 bld::pp::nemo     1
 bld::tool::fpp       $COMPIL_DIR/agrifpp.sh
-bld::tool::fppflags::nemo ${AGRIFUSE} %FPPFLAGS
-bld::tool::fppflags::ioipsl   0 %FPPFLAGS
+bld::tool::fppflags::nemo     %FPPFLAGS
+bld::tool::fppflags::ioipsl   %FPPFLAGS
 
 # Ignore the following dependencies
@@ -54,4 +55,12 @@
 bld::excl_dep        use::mod_comprism_proto
 bld::excl_dep        use::mkl_dfti
+bld::excl_dep        h::setnumberofcells.h
+bld::excl_dep        h::getnumberofcells.h
+bld::excl_dep        h::include_use_alloc_agrif.h
+bld::excl_dep        h::allocations_calls_agrif.h
+bld::excl_dep        h::modtype_agrif.h
+bld::excl_dep        h::probdim_agrif.h
+bld::excl_dep        h::keys_agrif.h
+
 # Don't generate interface files
 bld::tool::geninterface none